#!/usr/bin/perl
######################################################################
# HTML tools                              Version 1.0                #
# Copyright 1999 Frederic TYNDIUK (FTLS)  All Rights Reserved.       #
# E-Mail: tyndiuk@ftls.org                Script License: GPL        #
# Created  05/30/99                       Last Modified 05/30/99     #
# Scripts Archive at:                     http://www.ftls.org/cgi/   #
######################################################################
# Function :                                                         #
# Convert html symbol (like &eacute; egrave; ...) into , in a file #
# Help : ConvAsciiSymb.pl -h                                         #
######################################################################
##################### license & copyright header #####################
#                                                                    #
#                 Copyright (c) 1999 TYNDIUK Frederic                #
#                                                                    #
#  This program is free software; you can redistribute it and/or     #
#  modify it under the terms of the GNU General Public License as    #
#  published by the Free Software Foundation; either version 2 of    #
#  the License, or (at your option) any later version.               #
#                                                                    #
#  This program is distributed in the hope that it will be useful,   #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of    #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     #
#  GNU General Public License for more details.                      #
#                                                                    #
#  You should have received a copy of the GNU General Public License #
#  along with this program in the file 'COPYING'; if not, write to   #
#  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,  #
#  Boston, MA 02111-1307, USA, or contact the author:                #
#                                                                    #
#                              TYNDIUK Frederic <tyndiuk@ftls.org>   #
#                                       <http://www.ftls.org/>       #
#                                                                    #
################### end license & copyright header ###################
######################################################################
# Necessary Variables                                                #
#                                                                    #
$File_Code = "./htmlcode.txt";
######################################################################
# Init Variables :
$Verbose = 1;
$Recursive = 0;
$ascii2html = $html2ascii = 0;

####### Test Argmuments
	if (@ARGV < 2) { &Usage; }
	while ($ARGV[0] =~ /^-/) {
		if (($ARGV[0] eq "-R")   || ($ARGV[0] eq "--recursive"))  { $Recursive = 1;}
		if (($ARGV[0] eq "-q")   || ($ARGV[0] eq "--quiet") || ($ARGV[0] eq "--silent")) { $Verbose = 0;}
		if (($ARGV[0] eq "-h2a") || ($ARGV[0] eq "--html2ascii")) { $html2ascii = 1; }
		if (($ARGV[0] eq "-a2h") || ($ARGV[0] eq "--ascii2html")) { $ascii2html = 1;}
		if (($ARGV[0] eq "-t")   || ($ARGV[0] eq "--conv-tab"))   { shift(@ARGV); $File_Code = $ARGV[0]; }
	shift(@ARGV);
	}
if (!($ascii2html || $html2ascii)) { &Usage; }
	$File = $ARGV[0];
	$Dir = $ARGV[0];

# Open The Symbole file.
open(COM, "$File_Code") || die("Cannot open file $File_Code, Error $!");
@SymbTab = <COM>;
close(COM);

if ($Recursive) {
	&RecursProc($Dir);
} else {
	foreach $File (@ARGV) {
		if (-d $File) {
			print STDERR ("$0: $File: is a directory\n") }
		else {
			&ConvPage($File)
		}
	}
}

# Recursive Procedure
sub RecursProc {
	my($Dir) = @_;
	my($cmd, $file, @list);
	$cmd = "find $Dir/ -name '*.html'";
	open(LISTFILE, "$cmd|");
	@list = <LISTFILE>;
	close(LISTFILE);
    foreach $file (@list) {
    	$file =~ s/\n//;
    	$file =~ s/\/\//\//;
		&ConvPage($file);
	}
}

sub ConvPage {
	my($File_Src) = @_;
	if ($Verbose) { print "Convert $File_Src\n"; }
	
	open(COM, "$File_Src") || die("Cannot open file $File_Src, Error $!");
	@Fiche = <COM>;
	close(COM);
	$i = 0;
	foreach $line (@Fiche) {
		foreach $SymbLine (@SymbTab) {
			if ($SymbLine !~ /^ *#/) { # Comment Symbol
				($ascii, $html) = split(/\s\s*/,$SymbLine);
				if ($html2ascii) {
					$line =~ s/$html/$ascii/g;
				} else {
					$line =~ s/$ascii/$html/g;
				}
			}
		}
		$Fiche[$i] = $line;
		$i++;
		}
	open(COM, ">$File_Src") || die("Cannot open file $File_Src, Error $!");
	print COM @Fiche;
	close(COM);
	}

sub Usage {
	print STDERR ("USAGE: $0 [-h2a/-a2h] [Option] File1/dir File2 File3...\n");
	print STDERR ("   -h2a,      --html2ascii       Convert html code to ascii\n");
	print STDERR ("   -a2h,      --ascii2html       Convert ascii code to html\n");
	print STDERR ("   -q,        --quit, --silent   turn off verboseness\n");
	print STDERR ("   -R,        --recursive        convert *.html recursively (using find)\n");
	print STDERR ("   -t File,   --conv-tab File    Use File for convert default 'htmlcode.txt'\n");
	exit 1;
}
